
var dmActiveDownloads  = [];
window.addEventListener("load", dminit, true);
window.addEventListener('close', dmexit, true);

function initPrefs()
{
  try {
    document.getElementById("closeWhenDone").disabled = true;
    document.getElementById("showWhenStarting").disabled = true;
  } catch (e) {}
  /*
  try {
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var winVal = preferencesService.getIntPref("downloadmgr.windowType");
    if (winVal == 0) {
      var show = preferencesService.getBoolPref("downloadmgr.showWhenStarting");
      document.getElementById("showWhenStarting").checked = show;

      var close = preferencesService.getBoolPref("downloadmgr.closeWhenDone");
      document.getElementById("closeWhenDone").checked = close;
    }
    else {
      document.getElementById("showWhenStarting").checked = false;
      document.getElementById("closeWhenDone").checked = false;
    }
  } catch (e) {}
  */
  try {
    document.getElementById("showWhenStarting").checked = false;
    document.getElementById("closeWhenDone").checked = false;
  } catch (e) {}
}

function dmShowOptions()
{
  openDialog("chrome://downloadmgr/content/options/options.xul", "", "modal=yes");
  initPrefs();
}

function toggleDownloadMgr(open, close)
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var window = preferencesService.getIntPref("downloadmgr.windowType");

  // Open Download Manager as a side bar
  if (window == 1) {
    if (open && close) toggleSidebar('viewDMSidebar');
    else if (open) toggleSidebar('viewDMSidebar',true);
  }

  // Open Download Manager as a tab
  else if (window == 2) {
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;

    if (close && getWebNavigation().currentURI.spec == "chrome://downloadmgr/content/downloadtab.xul") {
      BrowserCloseTabOrWindow();
      return;
    }

    while (index < numTabs) {
      getBrowser().selectedTab = gBrowser.mTabContainer.childNodes[index];

      var url = getWebNavigation().currentURI.spec;

      if (url == "chrome://downloadmgr/content/downloadtab.xul") {
        break;
      }
      else index = index+1;
    }

    if (open && index == numTabs) {
      var dmTab = gBrowser.addTab('chrome://downloadmgr/content/downloadtab.xul');
      dmTab.label = "Downloads";

      if (!gPrefService.getBoolPref("downloadmgr.loadTabInBackground"))
        getBrowser().selectedTab = dmTab;
      else getBrowser().selectedTab = oldTab;
      //getBrowser().selectedTab = dmTab;
    }
    else if (!close && gPrefService.getBoolPref("downloadmgr.loadTabInBackground")) getBrowser().selectedTab = oldTab;
  }

  // Open Download Manager as a window
  else {
    if (open) toOpenWindowByType('Download:Manager','chrome://mozapps/content/downloads/downloads.xul','chrome,dialog=no,resizable');
  }
}

function dmCompleted(aDownload)
{
  try {
    // Remove the download from our book-keeping list and if the count
    // falls to zero, update the title here, since we won't be getting
    // any more progress notifications in which to do it.
    for (var i = 0; i < dmActiveDownloads.length; ++i) {
      if (dmActiveDownloads[i] == aDownload) {
        dmActiveDownloads.splice(i, 1);
        break;
      }
    }
  }
  catch (e) {
  }
}

function dmAutoClose()
{
  // If files are still downloading, don't close the DM
  if (dmActiveDownloads.length > 0) return;
  // or if the user opened the DM, don't automatically close it
  //else if (window.opener && window.opener.location.href != window.location.href) return;

  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  var window = preferencesService.getIntPref("downloadmgr.windowType");

  // Close Download Manager in a side bar
  if (window == 1) {
	var title = "Downloads";
    var sidebarTitle = document.getElementById("sidebar-title");
    if (sidebarTitle.value == title) toggleSidebar('viewDMSidebar', false);
  }

  // Close Download Manager in a tab
  else if (window == 2) {
    var numTabs = gBrowser.mTabContainer.childNodes.length;
    var index = 0;
    var oldTab = getBrowser().selectedTab;

    if (close && getWebNavigation().currentURI.spec == "chrome://downloadmgr/content/downloadtab.xul") {
      if (!gPrefService.getBoolPref("downloadmgr.loadTabInBackground")) BrowserCloseTabOrWindow();
      return;
    }

    while (index < numTabs) {
      getBrowser().selectedTab = gBrowser.mTabContainer.childNodes[index];

      var url = getWebNavigation().currentURI.spec;

      if (url == "chrome://downloadmgr/content/downloadtab.xul") {
        BrowserCloseTabOrWindow();
        return;
      }
      else index = index+1;
    }
    getBrowser().selectedTab = oldTab;
  }

}

var dmDownloadObserver = {
  observe: function (aSubject, aTopic, aState)
  {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    switch (aTopic) {
    case "dl-done":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);

	  try {
	 	var close = pref.getBoolPref("downloadmgr.closeWhenDone");
	  } catch (e) {}

	  if (close != false) dmAutoClose();
      break;
    case "dl-failed":
    case "dl-cancel":
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmCompleted(dl);
      break;
    case "dl-start":
      // Add this download to the percentage average tally
      var dl = aSubject.QueryInterface(Components.interfaces.nsIDownload);
      dmActiveDownloads.push(dl);
	  try {
	 	var show = pref.getBoolPref("downloadmgr.showWhenStarting");
	  } catch (e) {}

	  if (show != false) toggleDownloadMgr(true,false);
      break;
    case "xpinstall-download-started":
//      var windowArgs = aSubject.QueryInterface(Components.interfaces.nsISupportsArray);
//      var params = windowArgs.QueryElementAt(0, Components.interfaces.nsISupportsInterfacePointer);
//      params = params.data.QueryInterface(Components.interfaces.nsIDialogParamBlock);
//      var installObserver = windowArgs.QueryElementAt(1, Components.interfaces.nsISupportsInterfacePointer);
//      installObserver = installObserver.data.QueryInterface(Components.interfaces.nsIObserver);
//      XPInstallDownloadManager.addDownloads(params, installObserver);
      break;
    case "xpinstall-dialog-close":
//      if ("gDownloadManager" in window) {
//        var mgr = gDownloadManager.QueryInterface(Components.interfaces.nsIXPInstallManagerUI);
//        gCanAutoClose = mgr.hasActiveXPIOperations;
//        autoClose();
//      }
      break;
    }
  }
};

function dminit()
{
  window.removeEventListener("load", dminit, true);

  // Handlers for events generated by the Download Manager (download events)
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.addObserver(dmDownloadObserver, "dl-done",   false);
  observerService.addObserver(dmDownloadObserver, "dl-cancel", false);
  observerService.addObserver(dmDownloadObserver, "dl-failed", false);
  observerService.addObserver(dmDownloadObserver, "dl-start",  false);
  //observerService.addObserver(dmDownloadObserver, "dl-progress",  false);
//  observerService.addObserver(dmDownloadObserver, "xpinstall-download-started", false);
//  observerService.addObserver(dmDownloadObserver, "xpinstall-dialog-close",     false);

  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  try {
    pref.setBoolPref("browser.download.manager.showWhenStarting", false);
    pref.setBoolPref("browser.download.manager.closeWhenDone", false);

    if(!prefService.prefHasUserValue("downloadmgr.windowType"))
      prefService.setIntPref("downloadmgr.windowType", 0);

    if(!prefService.prefHasUserValue("downloadmgr.showWhenStarting"))
      prefService.setBoolPref("downloadmgr.showWhenStarting", true);

    if(!prefService.prefHasUserValue("downloadmgr.closeWhenDone"))
      prefService.setBoolPref("downloadmgr.closeWhenDone", false);

    if(!prefService.prefHasUserValue("downloadmgr.bottomToolBar"))
      prefService.setBoolPref("downloadmgr.bottomToolBar", false);

    if(!prefService.prefHasUserValue("downloadmgr.buttonDownload"))
      prefService.setBoolPref("downloadmgr.buttonDownload", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonLaunch"))
      prefService.setBoolPref("downloadmgr.buttonLaunch", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonShow"))
      prefService.setBoolPref("downloadmgr.buttonShow", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonClean"))
      prefService.setBoolPref("downloadmgr.buttonClean", true);

    if(!prefService.prefHasUserValue("downloadmgr.buttonOptions"))
      prefService.setBoolPref("downloadmgr.buttonOptions", true);

    if(!prefService.prefHasUserValue("downloadmgr.loadTabInBackground"))
      prefService.setBoolPref("downloadmgr.loadTabInBackground", true);

    //initPrefs();

  } catch (e) {}
}

function dmexit(aEvent)
{
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                  .getService(Components.interfaces.nsIObserverService);
  observerService.removeObserver(dmDownloadObserver, "dl-done");
  observerService.removeObserver(dmDownloadObserver, "dl-cancel");
  observerService.removeObserver(dmDownloadObserver, "dl-failed");
  observerService.removeObserver(dmDownloadObserver, "dl-start");
}
